<?php
/**
* Joomla IR GeoData plugin helper (backend)
* alexey@gnevyshev.ru
*/
defined( '_JEXEC' ) or die;

if (!function_exists('irprint')) {
    function irprint($something, $text = '')
    {
        $sapi = php_sapi_name();
        if (!empty($text)) echo $text.':'.PHP_EOL;
        if ($sapi != 'cli') echo '<pre>';
        $print = $something;
        if (empty($something)) $print = 'empty';
        if ($something === 0 || $something === (float) 0 || $something === '0') $print = 0;
        print_r($print);
        if ($sapi != 'cli') echo '</pre>';
        echo PHP_EOL;
    }
}

function irgd_getPluginId()
{
    $db = JFactory::getDbo();
    $query = 'SELECT extension_id FROM #__extensions WHERE type = "plugin" AND folder = "system" AND element = "irgeodata"';
    $db->setQuery($query);
    return $db->loadResult();
}

function irgd_checkDat()
{
    $is_exist = false;
    if (file_exists(__DIR__.DS.'sypex_geo'.DS.'SxGeoCity.dat')) {
        $is_exist = true;
    }
    return $is_exist;
}

function irgd_getSypexUpdated()
{
    $mod = filemtime(__DIR__.DS.'sypex_geo'.DS.'SxGeoCity.dat');
    return $mod;
}

function irgd_insertDownloadJs($download_link)
{
    $doc = JFactory::getDocument();
    $doc->addScriptDeclaration('
        jQuery(function($) {
            $(".download-base-link.active").on("click", function() {
                if ($(this).hasClass("active")) {
                    $(".download-base-link").removeClass("btn-primary active").addClass("btn-secondary");
                    $(".download-base-result").html("<p><img src=\"/plugins/system/irgeodata/img/preloader.gif\" alt=\"Processing\" /></p>");
                    var data = {
                        download_url: "'.$download_link.'"
                    };
                    $.ajax({
                        url: "/plugins/system/irgeodata/ajax.php?task=download",
                        type: "POST",
                        data: data,
                        cache: false,
                        dataType: "json"
                    })
                    .done(function(response) {
                        var html = "<pre>";
                        html += response.txt;
                        html += "</pre>";
                        if (response.success) {
                            html += "<p>Результат обновления: <span style=\"color: green;\">УСПЕШНО</span></p>"
                        } else {
                            html += "<p>Результат обновления: <span style=\"color: red;\">НЕ УДАЛОСЬ</span></p>"
                        }
                        $(".download-base-result").html(html);
                        
                        // обновить дату в поле - если открыты настройки плагина
                        if (window.ir_geo_data_plugin_configure) {
                            $("#jform_params_last_update").val(response.updated);
                        }
                    })
                    .fail(function() {
                        $(".download-base-result").html("<pre>Something\'s wrong</pre>");
                        $(".download-base-link").removeClass("btn-secondary").addClass("btn-primary active");
                    });
                }
            });
        });
    ');
}

function irgd_checking($check_sypex_geo, $download_link, $frequency_check_update)
{
    $app = JFactory::getApplication();
    $message = '';
    
    // check existing
    $check_dat = irgd_checkDat();
    if (!$check_dat) {
        $message .= 'Не обнаружено файла с данными городов.<br />';
    }
    
    // check update
    if ($check_sypex_geo) {
        $upd_date = irgd_getSypexUpdated();
        if ($upd_date) {
            $time_ok = time() - $frequency_check_update*24*3600;
            if ($upd_date < $time_ok) {
                $message .= 'Пора обновить базу Sypex Geo с данными городов.<br />';
            }
        } else {
            $message .= 'Не удалось проверить дату обновления загруженной базы.<br />';
        }
    }
    
    if (!empty($message)) {
        $message = '<p><strong>Сообщение плагина IR Geo Data</strong><br />'.$message;
        $message .= 'Скачать базу с сайта Sypex Geo?</p>';
        $message .= '<p><a href="#" class="btn btn-primary download-base-link active">Скачать</a></p>';
        $message .= '<p class="download-base-result"></p>';
        $app->enqueueMessage($message, 'warning');
        irgd_insertDownloadJs($download_link);
    }
}

function irgd_checkSypexData($check_sypex_geo, $download_link, $frequency_check_update)
{
    $app = JFactory::getApplication();
    if ($app->isAdmin()) {
        
        $cmd_compon = $app->input->get('option');
        $cmd_view   = $app->input->get('view');
        $cmd_layout = $app->input->get('layout');
        $cmd_ext_id = $app->input->get('extension_id');
        
        if ($cmd_compon == 'com_plugins' && $cmd_view == 'plugin' && $cmd_layout == 'edit') {
            $geodata_plugin_id = irgd_getPluginId();
            if ($cmd_ext_id == $geodata_plugin_id) {
                // this plugin editing
                
                // for update date input on plugin configure
                $doc = JFactory::getDocument();
                $doc->addScriptDeclaration('window.ir_geo_data_plugin_configure = 1;');
                
                // actuality
                $upd_date = irgd_getSypexUpdated();
                if ($upd_date) {
                    $act = date('d.m.Y', $upd_date);
                    $message_type = 'message';
                    if (time() > ($upd_date + 20*24*3600)) {
                        $message_type = 'warning';
                    }
                    $app->enqueueMessage('Актуальность базы: '.$act, $message_type);
                }
                
                if (!$check_sypex_geo) {
                    irgd_checking($check_sypex_geo, $download_link, $frequency_check_update);
                }
            }
        }
        
        if ($check_sypex_geo) {
            irgd_checking($check_sypex_geo, $download_link, $frequency_check_update);
        }
    }
}






