<?php
// Обновление файла базы данных Sypex Geo

/*
// Настройки
$url = 'https://sypexgeo.net/files/SxGeoCountry.zip';  // Путь к скачиваемому файлу
$dat_file_dir = './'; // Каталог в который сохранять dat-файл
$last_updated_file = __DIR__ . '/SxGeo.upd'; // Файл в котором хранится дата последнего обновления
define('INFO', true); // Вывод сообщений о работе, true заменить на false после установки в cron
// Конец настроек
*/

set_time_limit(600);
//error_reporting(E_ALL);
header('Content-type: text/plain; charset=utf8');

function sxgeo_update($url = '', $last_updated_file = '', $dat_file_dir = '', $info = true)
{
    $answer = new stdClass();
    $answer->txt = '';
    $answer->success = 0;
    
    chdir(__DIR__);
    $types = array(
        'Country' =>  'SxGeo.dat',
        'City' =>  'SxGeoCity.dat',
        'Max' =>  'SxGeoMax.dat',
    );
    // Скачиваем архив
    preg_match("/(Country|City|Max)/", pathinfo($url, PATHINFO_BASENAME), $m);
    $type = $m[1];
    $dat_file = $types[$type];
    if ($info) $answer->txt .= 'Скачиваем архив с сервера'.PHP_EOL;
    $fp = fopen(__DIR__ .'/SxGeoTmp.zip', 'wb');
    $ch = curl_init($url);
    curl_setopt_array($ch, array(
        CURLOPT_FILE => $fp,
        CURLOPT_HTTPHEADER => file_exists($last_updated_file) ? array("If-Modified-Since: " .file_get_contents($last_updated_file)) : array()
    ));
    if(!curl_exec($ch)) {
        $answer->txt .= 'Ошибка при скачивании архива'.PHP_EOL;
        return $answer;
    }
    $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);
    fclose($fp);
    if ($code == 304) {
        @unlink(__DIR__ . '/SxGeoTmp.zip');
        if ($info) $answer->txt .= 'Архив не обновился, с момента предыдущего скачивания'.PHP_EOL;
        return $answer;
    } elseif ($code >= 400) {
        if ($info) $answer->txt .= 'По указанной ссылке не удалось скачать архив'.PHP_EOL;
        return $answer;
    }
    if ($info) $answer->txt .= 'Архив с сервера скачан'.PHP_EOL;
    
    // Распаковываем архив
    $fp = fopen('zip://' . __DIR__ . '/SxGeoTmp.zip#' . $dat_file, 'rb');
    $fw = fopen($dat_file, 'wb');
    if (!$fp) {
        $answer->txt .= 'Не получается открыть'.PHP_EOL;
        return $answer;
    }
    if ($info) $answer->txt .= 'Распаковываем архив'.PHP_EOL;
    stream_copy_to_stream($fp, $fw);
    fclose($fp);
    fclose($fw);
    if(filesize($dat_file) == 0) {
        $answer->txt .= 'Ошибка при распаковке архива'.PHP_EOL;
        return $answer;
    }
    @unlink(__DIR__ . '/SxGeoTmp.zip');
    $ren_res = rename(__DIR__ . '/' . $dat_file, $dat_file_dir . $dat_file);
    if (!$ren_res) {
        $answer->txt .= 'Ошибка при переименовании файла'.PHP_EOL;
        return $answer;
    }
    file_put_contents($last_updated_file, gmdate('D, d M Y H:i:s') . ' GMT');
    if ($info) {
        $answer->txt .= "Обновлённую базу сохранили в файл: {$dat_file_dir}{$dat_file}\n";
        $answer->success = 1;
        
    }
    return $answer;
}

